/*
AcetoneISO2  written by Fabrizio Di Marco and Marco Di Antonio
is released under the terms of the GNU General Public Licence v.3.0 2007
*/
#include <QtGui> 
#include "acetoneiso.h"
#include <fcntl.h>
#include <iostream>
#include <QTimer>
#include <QProcess>
#include <QUrl>
#include <QtXml>
#include <QProgressBar>
#include"a_md5check.h"
#include"a_md5generate.h"
#include"a_mount.h"
#include"a_encrypt.h"
#include"a_umount.h"
#include"a_foldertoiso.h"
#include"a_donate.h"
//#include"a_manual.h"
#include"a_psxrip.h"
#include"a_compress.h"
#include"a_extract.h"
#include"a_converter.h"
#include"a_decrypt.h"
#include"a_isocd.h"
#include"a_merge.h"
#include"a_split.h"
#include"a_uncompress.h"
#include"a_play.h"
#include"a_unplay.h"
#include"a_gencue.h"
#include"a_database.h"
#include"a_gumount.h"
#include"a_gmount.h"
#include"a_elfloppy.h"
#include"a_macimg.h"
#include"a_eltorito.h"
#include"a_backup_audio.h"
#include"a_mdatabase.h"
#include"a_getboot.h"
#include"a_remove_from_database.h"
#include"a_messages.h"
#include"a_open_mounted.h"
#include"a_status_mounted.h"
#include"a_poweriso.h"
#include"a_dvd_cover.h"
#include"options.h"
#include"about.h"
#include"progress.h"
#include"manual.h"
#include"a_udf.h"
#include"a_rip.h"
#include"a_vidgen.h"
#include"a_flvavi.h"
#include"a_utube.h"
// if we include <QtGui> there is no need to include every class used: <QString>, <QFileDialog>,...



acetoneiso::acetoneiso()
{

QPixmap splashpng(":/images/splash.png");
QSplashScreen *splash = new QSplashScreen(splashpng);
splash->show();
splash->showMessage(tr("Loading GUI..."));



  QDir Temp = QDir::temp();
  Temp.mkdir("acetoneiso");

  QDir Home = QDir::home();
  Home.mkdir("virtual-drives");
  Home.cd("virtual-drives");
  Home.mkdir("1");
  Home.mkdir("2");
  Home.mkdir("3");
  Home.mkdir("4");
  Home.mkdir("5");
  Home.mkdir("6");
  Home.mkdir("7");
  Home.mkdir("dvd");
  Home.mkdir("../.acetoneiso");
  Home.cd(".acetoneiso");

    setupUi(this); // this sets up GUI

    // signals/slots mechanism in action
    connect( actionConvert_MacOs_Image_2, SIGNAL ( triggered() ), this, SLOT ( macimg() ) );
    connect( pushButton, SIGNAL( clicked() ), this, SLOT( mount() ) ); 
    connect( pushButton_2, SIGNAL( clicked() ), this, SLOT( umount() ) ); 
    connect( pushButton_3, SIGNAL( clicked() ), this, SLOT( a_donate() ) );
    connect( pushButton_4, SIGNAL( triggered() ), this, SLOT( extract() ) ); 
   // connect( actionManual, SIGNAL( triggered() ), this, SLOT( Manual() ) );
    connect( actionExit, SIGNAL( triggered() ), qApp, SLOT( quit() ) );
    connect( actionSet_Database, SIGNAL( triggered() ), this, SLOT ( database() ) );
    connect( pushButton_Omni_3, SIGNAL( triggered() ), this, SLOT( converter() ) );
    connect( pushButton_IsoFromFolder_2, SIGNAL( triggered() ), this, SLOT( foldertoiso() ) );
    connect( pushButton_PSX_Rip_2, SIGNAL( triggered() ), this, SLOT( psxrip() ) );
    connect( button_backup_audio, SIGNAL( triggered() ), this, SLOT( backupaudio() ) );
    connect( pushButton_Compress, SIGNAL( triggered() ), this, SLOT( compress() ) ); 
    connect( pushButton_Decrypt_2, SIGNAL( triggered() ), this, SLOT( decrypt() ) );
    connect( pushButton_Encrypt_2, SIGNAL( triggered() ), this, SLOT( encrypt() ) );
    connect( pushButton_IsoFromCD_2, SIGNAL( triggered() ), this, SLOT( isocd() ) );
    connect( pushButton_Merge_2, SIGNAL( triggered() ), this, SLOT( merge() ) );
    connect( pushButton_SplitIso_2, SIGNAL( triggered() ), this, SLOT( split() ) );
    connect( pushButton_Ucompress, SIGNAL( triggered() ), this, SLOT( uncompress() ) );
    connect( pushButton_Play, SIGNAL( clicked() ), this, SLOT( play() ) );
    connect( pushButton_UnPlay, SIGNAL( clicked() ), this, SLOT( unplay() ) );
    connect( pushButton_GenCUE, SIGNAL( triggered() ), this, SLOT( gencue() ) );
    connect( actionMount_UDF_ISO_2, SIGNAL( triggered() ), this, SLOT( udf() ) );
    connect( actionRip_DVD_2_Xvid, SIGNAL( triggered() ), this, SLOT( rip() ) );
    connect( actionConvert_generic_video, SIGNAL( triggered() ), this, SLOT( vidgeneric() ) );
    connect( actionYouTube_Download_Video, SIGNAL( triggered() ), this, SLOT( utube() ) );
    connect( actionConvert_FLV_2_AVI, SIGNAL( triggered() ), this, SLOT( flvavi() ) );
    connect( pushButton_database, SIGNAL( clicked() ), this, SLOT( database() ));
    connect( actionGenerate_Md5, SIGNAL( triggered() ), this, SLOT( md5generate() ) );
    connect( actionCheck_Md5, SIGNAL( triggered() ), this, SLOT( md5check() ) );
    connect( actionGeneric_Mount_2, SIGNAL( triggered() ), this, SLOT( gmount() ) );
    connect( actionGeneric_Umount_2, SIGNAL( triggered() ), this, SLOT( gumount() ) );
    connect( actionGeneric_Floppy_Emulation_2, SIGNAL( triggered() ), this, SLOT( elfloppy() ) );
    connect( actionGeneric_No_Emulation_2, SIGNAL( triggered() ), this, SLOT( eltorito() ) );
    connect( actionExtract_Boot_Image_2, SIGNAL( triggered() ), this, SLOT( getboot() ) );
    connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOut(int, QProcess::ExitStatus)));
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutgpg(int, QProcess::ExitStatus)));
    connect( &PSxrip, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &PSxrip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutpsx(int, QProcess::ExitStatus)));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcompress(int, QProcess::ExitStatus)));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutsplit(int, QProcess::ExitStatus)));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutuncompress(int, QProcess::ExitStatus)));
    connect( listWidget, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(mdatabase(QListWidgetItem *) ) );
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutisofromcd(int, QProcess::ExitStatus)));
    connect( listWidget_2, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(open_mounted(QListWidgetItem *) ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(messaggio_poweriso()));
    connect( &POweriso, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &POweriso, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( message_extract_finish() ) );
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcue(int, QProcess::ExitStatus)));
    connect( &BAckaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &BAckaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutbackaudio(int, QProcess::ExitStatus)));
    connect( &MAcimg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &MAcimg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( printOutMACIMG(int, QProcess::ExitStatus) ) );
    connect( pushButton_delImage, SIGNAL( clicked() ), this, SLOT( remove_fromDatabase() ) );
    connect( pushButton_updateDB, SIGNAL( clicked() ), this, SLOT( initial_get_database() ) );
    connect( &WGet2, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( mergeMSG(int, QProcess::ExitStatus) ) );
    connect( &FUse, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutfuseiso(int, QProcess::ExitStatus)));
    connect( &ELtorito, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TOc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( button_saveCover, SIGNAL( clicked() ), this, SLOT( save_cover() ) );
    connect( &RIp, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIp, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutrip(int, QProcess::ExitStatus)));
    connect( &RIp2, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIp2, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutrip2(int, QProcess::ExitStatus)));
    connect( &VIdgen, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &VIdgen, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutvidgen(int, QProcess::ExitStatus)));
    connect( &FLv, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &FLv, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutflv(int, QProcess::ExitStatus)));
    connect( &UTube, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &UTube, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOututube(int, QProcess::ExitStatus)));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutumount(int, QProcess::ExitStatus)));
	/*#############################################*/

button_saveCover->setVisible(false);	
status_mounted();
initial_get_database();

listWidget_2->setAcceptDrops(true);
//progress1Bar->setVisible( false );

splash->showMessage(tr("Loading Options..."));

createOption();

splash->finish(this);


	
}


void acetoneiso::progBarra()
{
      prog.show();
}


void acetoneiso::closeProg()
{
prog.close();
}

void acetoneiso::on_options_nda_activated()
{
	optionsDiag *opt=new optionsDiag;
	opt->exec();
}

void acetoneiso::createOption()
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
if( !file.exists() ) {
   file.open(QIODevice::WriteOnly | QIODevice::Text);
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = standard\n" );
   out << ( "PLAYER = kaffeine\n" );
   out << ( "FILE_BROWSER = kde\n" );
   file.close();
   }
}

void acetoneiso::on_actionAbout_activated()
{
	aboutDiag *abt=new aboutDiag;
	abt->exec();
}


void acetoneiso::on_actionManual_activated()
{
	manualDiag *man=new manualDiag;
	man->exec();
}

void acetoneiso::save_cover()
{
QDir Home = QDir::home();
QDir Temp = QDir::temp();
Temp.cd("acetoneiso");
QFile dvd_name_file( Temp.path() + "/dvd" );
dvd_name_file.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString dvd_name = (dvd_name_file.readAll());
QFile file( Temp.path() + "/cov.jpg" );

		 	QString fileName = QFileDialog::getSaveFileName(this, tr("AcetoneISO2::Save DVD Cover"),
										Home.path() + "/" + dvd_name,
										tr("Images (*.jpg)"));
			
			if ( fileName.isNull() )
			{
			}
			else
			{
			   file.copy( fileName );
			}
}

